## openvas-scanner 23.30.1

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Greenbone AG
#
# SPDX-License-Identifier: GPL-2.0-or-later

cmake_minimum_required (VERSION 3.10)

message ("-- Configuring the Scanner...")

# VERSION: Always include major, minor and patch level.
project (openvas
  VERSION 23.30.1
  LANGUAGES C)

if (POLICY CMP0005)
  cmake_policy (SET CMP0005 NEW)
endif (POLICY CMP0005)

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Debug)
endif (NOT CMAKE_BUILD_TYPE)

OPTION (ENABLE_COVERAGE "Enable support for coverage analysis" OFF)

## Retrieve git revision (at configure time)
include (GetGit)

if (NOT CMAKE_BUILD_TYPE MATCHES "Release")
  if (EXISTS "${CMAKE_SOURCE_DIR}/.git/")
    if (GIT_FOUND)
      Git_GET_REVISION(${CMAKE_SOURCE_DIR} ProjectRevision)
      set (GIT_REVISION "~git-${ProjectRevision}")
    endif (GIT_FOUND)
  endif (EXISTS "${CMAKE_SOURCE_DIR}/.git/")
endif (NOT CMAKE_BUILD_TYPE MATCHES "Release")

## make format
message (STATUS "Looking for clang-format...")
find_program (CLANG_FORMAT clang-format)
if (CLANG_FORMAT)
  message (STATUS "Looking for clang-format... ${CLANG_FORMAT}")
  add_custom_target(format COMMAND ${CLANG_FORMAT} "-i" "./src/*.c" "./misc/*.c"
                    "./nasl/*.c" "./src/*.h" "./misc/*.h" "./nasl/*.h"
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")
else (CLANG_FORMAT)
  message (STATUS "clang-format not found...")
endif (CLANG_FORMAT)

# Set dev version if this is a development version and not a full release,
# unset (put value 0 or delete line) before a full release and reset after.
set (PROJECT_DEV_VERSION 0)

# If PROJECT_DEV_VERSION is set, the version string will be set to:
#   "major.minor.patch~dev${PROJECT_DEV_VERSION}${GIT_REVISION}"
# If PROJECT_DEV_VERSION is NOT set, the version string will be set to:
#   "major.minor.patch${GIT_REVISION}"
# For CMAKE_BUILD_TYPE "Release" the git revision will be empty.
if (PROJECT_DEV_VERSION)
  set (PROJECT_VERSION_SUFFIX "~dev${PROJECT_DEV_VERSION}")
endif (PROJECT_DEV_VERSION)

set (PROJECT_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}${PROJECT_VERSION_SUFFIX}${GIT_REVISION}")

## CPack configuration

set (CPACK_CMAKE_GENERATOR "Unix Makefiles")
set (CPACK_GENERATOR "TGZ")
set (CPACK_INSTALL_CMAKE_PROJECTS ".;openvas;ALL;/")
set (CPACK_MODULE_PATH "")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set (CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set (CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/README.md")
set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_TOPLEVEL_TAG "")
set (CPACK_SYSTEM_NAME "")
set (CPACK_TOPLEVEL_TAG "")

set (CPACK_PACKAGE_VERSION "${PROJECT_VERSION_STRING}${PROJECT_VERSION_GIT}")

set (CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_PACKAGE_VENDOR "The OpenVAS Project")
set (CPACK_SOURCE_IGNORE_FILES
"${CMAKE_BINARY_DIR}"
"/.git/"
"swp$"
"nasl/nasl_grammar.tab.c"
"nasl/nasl_grammar.tab.h"
"nasl/nasl_grammar.output"
)

include (CPack)

## Variables

if (SYSCONF_INSTALL_DIR)
  set (SYSCONFDIR "${SYSCONF_INSTALL_DIR}")
endif (SYSCONF_INSTALL_DIR)

if (NOT SYSCONFDIR)
  set (SYSCONFDIR "/etc")
endif (NOT SYSCONFDIR)

if (NOT EXEC_PREFIX)
  set (EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
endif (NOT EXEC_PREFIX)

if (NOT BINDIR)
  set (BINDIR "${EXEC_PREFIX}/bin")
endif (NOT BINDIR)

if (NOT SBINDIR)
  set (SBINDIR "${EXEC_PREFIX}/sbin")
endif (NOT SBINDIR)

if (NOT LIBDIR)
  set (_DEFAULT_LIBRARY_INSTALL_DIR lib)
  if (EXISTS "${EXEC_PREFIX}/lib32/" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    set (_DEFAULT_LIBRARY_INSTALL_DIR lib32)
  endif (EXISTS "${EXEC_PREFIX}/lib32/" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  if (EXISTS "${CMAKE_INSTALL_PREFIX}/lib64/" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    set (_DEFAULT_LIBRARY_INSTALL_DIR lib64)
  endif (EXISTS "${CMAKE_INSTALL_PREFIX}/lib64/" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
  set( LIBRARY_INSTALL_DIR "${_DEFAULT_LIBRARY_INSTALL_DIR}")
  set (LIBDIR "${EXEC_PREFIX}/${LIBRARY_INSTALL_DIR}")
  message ("Set LIBDIR to ${LIBDIR}")
endif (NOT LIBDIR)

if (NOT LOCALSTATEDIR)
  set (LOCALSTATEDIR "/var")
endif (NOT LOCALSTATEDIR)

if (NOT DATADIR)
  set (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
endif (NOT DATADIR)

if (NOT OPENVAS_RUN_DIR)
  set (OPENVAS_RUN_DIR "/run/ospd")
endif (NOT OPENVAS_RUN_DIR)

if (NOT DEFINED BUILD_WITH_NETSNMP)
  set (BUILD_WITH_NETSNMP TRUE)
endif (NOT DEFINED BUILD_WITH_NETSNMP)

set (OPENVAS_DATA_DIR    "${DATADIR}/openvas")
set (OPENVAS_STATE_DIR   "${LOCALSTATEDIR}/lib/openvas")

if (NOT OPENVAS_FEED_LOCK_PATH)
  set (OPENVAS_FEED_LOCK_PATH "${OPENVAS_STATE_DIR}/feed-update.lock")
endif (NOT OPENVAS_FEED_LOCK_PATH)
add_definitions (-DOPENVAS_FEED_LOCK_PATH="${OPENVAS_FEED_LOCK_PATH}")

if (NOT GVM_LOG_DIR)
	set (GVM_LOG_DIR         "${LOCALSTATEDIR}/log/gvm")
endif (NOT GVM_LOG_DIR)
set (OPENVAS_SYSCONF_DIR "${SYSCONFDIR}/openvas")
set (GVM_SYSCONF_DIR     "${SYSCONFDIR}/gvm")

if (NOT OPENVAS_NVT_DIR)
  set (OPENVAS_NVT_DIR     "${OPENVAS_STATE_DIR}/plugins")
endif (NOT OPENVAS_NVT_DIR)

if (NOT GVM_ACCESS_KEY_DIR)
	set (GVM_ACCESS_KEY_DIR "${GVM_SYSCONF_DIR}")
endif (NOT GVM_ACCESS_KEY_DIR)

if (NOT OPENVAS_GPG_BASE_DIR)
	set (OPENVAS_GPG_BASE_DIR "${OPENVAS_SYSCONF_DIR}")
endif (NOT OPENVAS_GPG_BASE_DIR)

set (OPENVAS_LIB_INSTALL_DIR     "${LIBDIR}")

set (OPENVAS_CONF     "${OPENVAS_SYSCONF_DIR}/openvas.conf")

set (NVT_TIMEOUT "320")
set (SCANNER_NVT_TIMEOUT "36000")

message ("-- Install prefix: ${CMAKE_INSTALL_PREFIX}")

## Version

set (OPENVAS_VERSION "${PROJECT_VERSION_STRING}")

# Configure Doxyfile with version number
configure_file (doc/man/openvas.8.in doc/man/openvas.8 @ONLY)
configure_file (VERSION.in VERSION @ONLY)
configure_file (src/openvas_log_conf.cmake_in src/openvas_log.conf)


## Testing

enable_testing ()

add_custom_target (tests
                   DEPENDS attack-test pcap-test ipc-openvas-test lsc-test)

## Program

if (ENABLE_COVERAGE)
  set (COVERAGE_FLAGS "--coverage")
endif (ENABLE_COVERAGE)

set (HARDENING_FLAGS            "-Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector")
set (LINKER_HARDENING_FLAGS     "-Wl,-z,relro -Wl,-z,now")
# The "-D_FILE_OFFSET_BITS=64 -DLARGEFILE_SOURCE=1" is necessary for GPGME!
set (GPGME_C_FLAGS              "-D_FILE_OFFSET_BITS=64 -DLARGEFILE_SOURCE=1")

set (CMAKE_C_FLAGS_RELEASE      "${CMAKE_C_FLAGS_RELEASE} ${HARDENING_FLAGS}")
set (CMAKE_C_FLAGS_DEBUG        "${CMAKE_C_FLAGS_DEBUG} ${COVERAGE_FLAGS}")
set (CMAKE_C_FLAGS              "${CMAKE_C_FLAGS} ${GPGME_C_FLAGS} \
                                -std=c11 \
                                -Wall \
                                -Wextra \
                                -Werror \
                                -Wpedantic \
                                -Wmissing-prototypes \
                                -Wshadow \
                                -Wsequence-point \
                                -D_BSD_SOURCE \
                                -D_ISOC11_SOURCE \
                                -D_SVID_SOURCE \
                                -D_DEFAULT_SOURCE")

if (NOT SKIP_SRC)
  add_subdirectory (misc)
  add_subdirectory (nasl)
  add_subdirectory (src)
endif (NOT SKIP_SRC)

## Documentation

add_subdirectory (doc)


## Tests

enable_testing ()

## End

=== .devcontainer/Makefile ===
# TODO: 
# - add update script
# - change install-nvim to adapt update script to also update neovim


# Get the UID and GID of the user those will be used within the Dockerfile to share the same id between host and container.
UID := $(shell id -u)
GID := $(shell id -g)
MF_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
# if podman exists, use it instead of docker 
ifneq (,$(shell which podman))
	CONTAINERR=podman
else
	CONTAINERR=docker
endif
# disable docker hints, who needs that?
export DOCKER_CLI_HINTS=false

.PHONY: build

command-exists = $(CONTAINERR) exec -it openvas-dev command -v $(1) >/dev/null 2>&1 && echo "exists" || echo "not exists"
# @if [ "$$(basename $$SHELL)" = "fish" ]; then \
get-shell = $(basename $(notdir $(SHELL)))

build:
	$(CONTAINERR) build \
		--build-arg UID=$(UID) \
		--build-arg GID=$(GID) \
		-t openvas-dev:latest \
		.

start: 
	$(CONTAINERR) start openvas-dev

create:
	$(CONTAINERR) create -it \
		--name openvas-dev \
		-v $(HOME)/.ssh:/home/user/.ssh\
		-v $(HOME)/.config:/home/user/.config\
		-v $(HOME)/.gitconfig:/home/user/.gitconfig \
		openvas-dev:latest

is-running:
	$(CONTAINERR) ps -q --filter "name=openvas-dev" | grep -q . 

enforce-running:
	$(MAKE) is-running || $(MAKE) start || $(MAKE) create && $(MAKE) start 

install-fish: enforce-running
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "sudo apt update"
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "sudo apt install -y fish"
	# doesn't work because of attached tty on create there is no reinit of the shell
	#$(CONTAINERR) exec -it openvas-dev /bin/bash -c "sudo chsh -s /usr/bin/fish user"

install-pyright: enforce-running
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "pipx install pyright"


install-rg-fzf: enforce-running
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "sudo apt update"
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "sudo apt install -y ripgrep fzf"

install-nvim: install-rg-fzf
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "sudo apt install -y ninja-build gettext cmake unzip curl build-essential nodejs"
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "github-clone neovim/neovim"
	$(CONTAINERR) exec -it openvas-dev /bin/bash -c "cd /workspaces/neovim/neovim && make CMAKE_BUILD_TYPE=RelWithDebInfo && sudo make install"


enter: enforce-running
	@if $(call command-exists,fish); then \
		$(MAKE) enter-fish; \
	else \
		$(MAKE) enter-bash; \
	fi
	
enter-bash: enforce-running
	$(CONTAINERR) exec -it openvas-dev /bin/bash

# TODO: detect running shell and use that
enter-fish: enforce-running
	$(CONTAINERR) exec -it openvas-dev /usr/bin/fish

stop:
	-$(CONTAINERR) stop openvas-dev

rm: stop
	$(CONTAINERR) rm openvas-dev

=== misc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Greenbone AG
#
# SPDX-License-Identifier: GPL-2.0-or-later

## Dependency checks
##

include (FindPkgConfig)

if (NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "pkg-config executable not found. Aborting.")
endif (NOT PKG_CONFIG_FOUND)

pkg_check_modules (GLIB REQUIRED glib-2.0>=2.42)
pkg_check_modules (GLIB_JSON REQUIRED json-glib-1.0>=1.4.4)
pkg_check_modules (GNUTLS REQUIRED gnutls>=3.6.4)
pkg_check_modules (CURL REQUIRED libcurl>=7.74.0)

pkg_check_modules (KRB5 REQUIRED mit-krb5)
pkg_check_modules (KRB5_GSSAPI REQUIRED mit-krb5-gssapi)

pkg_check_modules (LIBGVM_BASE REQUIRED libgvm_base>=22.4)
pkg_check_modules (LIBGVM_UTIL REQUIRED libgvm_util>=22.4)
pkg_check_modules (LIBGVM_BOREAS REQUIRED libgvm_boreas>=22.4)

pkg_check_modules (OPENVAS_WMICLIENT libopenvas_wmiclient>=1.0.5)

message (STATUS "Looking for pcap...")
find_library (PCAP pcap)
message (STATUS "Looking for pcap... ${PCAP}")
if (NOT PCAP)
  message (SEND_ERROR "The pcap library is required.")
endif (NOT PCAP)

message (STATUS "Looking for pcap-config...")
find_program (PCAP_CONFIG pcap-config)

if (PCAP_CONFIG)
  message (STATUS "Looking for pcap-config... ${PCAP_CONFIG}")
  execute_process (COMMAND pcap-config --libs
    OUTPUT_VARIABLE PCAP_LDFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  string(STRIP ${PCAP_LDFLAGS} PCAP_LDFLAGS)
  execute_process (COMMAND pcap-config --cflags
    OUTPUT_VARIABLE PCAP_CFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
else (PCAP_CONFIG)
  message (STATUS "pcap-config not found, using defaults...")
  set (PCAP_LDFLAGS "-L/usr/lib -lpcap")
  set (PCAP_CFLAGS "-I/usr/include")
endif (PCAP_CONFIG)

message (STATUS "Looking for gpgme...")
find_library (GPGME gpgme)
message (STATUS "Looking for gpgme... ${GPGME}")
if (NOT GPGME)
  message (SEND_ERROR "The gpgme library is required.")
endif (NOT GPGME)

execute_process (COMMAND gpgme-config --libs
  OUTPUT_VARIABLE GPGME_LDFLAGS
  OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND gpgme-config --cflags
  OUTPUT_VARIABLE GPGME_CFLAGS
  OUTPUT_STRIP_TRAILING_WHITESPACE)

message (STATUS "Looking for libmagic...")
find_library (MAGIC magic)
message (STATUS "Looking for libmagic... ${MAGIC} ${MAGIC_LDFLAFS} ${MAGIC_INCLUDE_DIRS}")
if (MAGIC)
    set (MAGIC_LDFLAGS "-L/usr/lib -lmagic")
else (MAGIC)
  message (SEND_ERROR "The magic library is required.")
endif (MAGIC)

set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Werror")


## Pass-throughs
add_definitions (-DOPENVAS_MISC_VERSION="${PROJECT_VERSION_STRING}")

include_directories (${GLIB_INCLUDE_DIRS} ${GLIB_JSON_INCLUDE_DIRS}
                     ${LIBGVM_BASE_INCLUDE_DIRS}
                     ${GNUTLS_INCLUDE_DIRS} ${CURL_INCLUDE_DIRS} ${KRB5_INCLUDE_DIRS} ${KRB5_GSSAPI_INCLUDE_DIRS})

# Library

set (FILES bpf_share.c ftp_funcs.c vendorversion.c network.c plugutils.c pcap.c
     scan_id.c strutils.c table_driven_lsc.c ipc.c ipc_openvas.c ipc_pipe.c
     user_agent.c scanneraux.c kb_cache.c heartbeat.c openvas-krb5.c)

# On windows we are always PIC and stack-protector is replaces by DEP
# Also stack protection needs a shared library to work
set (CMAKE_C_FLAGS              "${CMAKE_C_FLAGS} -Wall -Wextra -fPIC")

# Build shared

add_library (openvas_misc_shared SHARED ${FILES})

set_target_properties (openvas_misc_shared PROPERTIES OUTPUT_NAME "openvas_misc")
set_target_properties (openvas_misc_shared PROPERTIES CLEAN_DIRECT_OUTPUT 1)
set_target_properties (openvas_misc_shared PROPERTIES SOVERSION "${PROJECT_VERSION_MAJOR}")
set_target_properties (openvas_misc_shared PROPERTIES VERSION "${PROJECT_VERSION_STRING}")

target_link_libraries (openvas_misc_shared LINK_PRIVATE
                       ${GNUTLS_LDFLAGS} ${UUID_LDFLAGS}
                       ${GLIB_LDFLAGS} ${GLIB_JSON_LDFLAGS} ${MAGIC_LDFLAGS}
                       ${PCAP_LDFLAGS} ${LIBGVM_BOREAS_LDFLAGS} ${CURL_LDFLAGS} ${KRB5_LDFLAGS} ${KRB5_GSSAPI_LDFLAGS}
                       ${LINKER_HARDENING_FLAGS})

if (OPENVAS_STATE_DIR)
  add_definitions (-DOPENVAS_STATE_DIR="${OPENVAS_STATE_DIR}")
endif (OPENVAS_STATE_DIR)

if (OPENVAS_DATA_DIR)
  add_definitions (-DOPENVAS_DATA_DIR="${OPENVAS_DATA_DIR}")
endif (OPENVAS_DATA_DIR)

# @todo Why is this definition setting guarded? OPENVAS_SYSCONF_DIR should
#       always be set.
#$(COMPILE) -DOPENVAS_STATE_DIR=\"$(localstatedir)\" -DCONF_DIR=\"$(sysconfdir)\" -c services1.c
if (OPENVAS_SYSCONF_DIR)
  add_definitions (-DOPENVAS_SYSCONF_DIR="${OPENVAS_SYSCONF_DIR}")
endif (OPENVAS_SYSCONF_DIR)

# install library

install (TARGETS openvas_misc_shared
         RUNTIME DESTINATION ${BINDIR}
         LIBRARY DESTINATION ${LIBDIR}
         ARCHIVE DESTINATION ${LIBDIR})

install (DIRECTORY DESTINATION ${GVM_LOG_DIR})
install (DIRECTORY DESTINATION ${OPENVAS_DATA_DIR})
install (DIRECTORY DESTINATION ${OPENVAS_SYSCONF_DIR})
install (DIRECTORY
  DESTINATION ${OPENVAS_SYSCONF_DIR}/gnupg
  DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_READ OWNER_WRITE)
install (DIRECTORY
  DESTINATION ${OPENVAS_STATE_DIR}/gnupg
  DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_READ OWNER_WRITE)

## Tests

enable_testing ()

set (LINK_LIBS_FOR_TESTS cgreen
                       ${LIBGVM_BASE_LDFLAGS}
                       ${GLIB_LDFLAGS}
                       ${PCAP_LDFLAGS} ${MAGIC_LDFLAGS}
                       ${CURL_LDFLAGS} ${KRB5_LDFLAGS} ${KRB5_GSSAPI_LDFLAGS}
                       ${LINKER_HARDENING_FLAGS} ${CMAKE_THREAD_LIBS_INIT}
                       ${ALIVEDETECTION_TEST_LINKER_WRAP_OPTIONS})

set (ALIVEDETECTION_TEST_LINKER_WRAP_OPTIONS
  "-Wl,-wrap,socket,-wrap,setsockopt")

# pcap-tests
add_executable (pcap-test EXCLUDE_FROM_ALL pcap_tests.c)
add_test (pcap-test pcap-test)
target_include_directories (pcap-test PRIVATE ${CGREEN_INCLUDE_DIRS})
target_compile_options(pcap-test PRIVATE "-fsanitize=address")
target_link_options(pcap-test PRIVATE "-fsanitize=address")
target_link_libraries (pcap-test cgreen
                       ${LIBGVM_BASE_LDFLAGS}
                       ${GLIB_LDFLAGS}
                       ${PCAP_LDFLAGS}
                       ${LINKER_HARDENING_FLAGS} ${CMAKE_THREAD_LIBS_INIT}
                       ${ALIVEDETECTION_TEST_LINKER_WRAP_OPTIONS})
set_tests_properties(
  pcap-test
  PROPERTIES
    ENVIRONMENT "ASAN_OPTIONS=detect_leaks=1:halt_on_error=1:abort_on_error=1"
)
add_custom_target (tests-pcap
                  DEPENDS pcap-test)

# ipc-openvas-tests
add_executable (ipc-openvas-test EXCLUDE_FROM_ALL ipc_openvas_tests.c)
add_test (ipc-openvas-test ipc-openvas-test)
target_include_directories (ipc-openvas-test PRIVATE ${CGREEN_INCLUDE_DIRS})
target_link_libraries (ipc-openvas-test cgreen
                       ${GLIB_LDFLAGS}
                       ${GLIB_JSON_LDFLAGS}
                       ${CURL_LDFLAGS} ${KRB5_LDFLAGS} ${KRB5_GSSAPI_LDFLAGS}
                       ${LINKER_HARDENING_FLAGS})

add_custom_target (tests-ipc-openvas
                  DEPENDS ipc-openvas-test)

# lsc-tests
add_executable (lsc-test EXCLUDE_FROM_ALL table_driven_lsc_tests.c kb_cache.c plugutils.c scan_id.c)
add_test (lsc-test lsc-test)
target_include_directories (lsc-test PRIVATE ${CGREEN_INCLUDE_DIRS})
target_link_libraries (lsc-test cgreen
                       ${LIBGVM_BASE_LDFLAGS}
                       ${LIBGVM_UTIL_LDFLAGS}
                       ${MAGIC_LDFLAGS}
                       ${GLIB_LDFLAGS}
                       ${GLIB_JSON_LDFLAGS}
                       ${CURL_LDFLAGS} ${KRB5_LDFLAGS} ${KRB5_GSSAPI_LDFLAGS}
                       ${LINKER_HARDENING_FLAGS})

add_custom_target (tests-lsc
                  DEPENDS lsc-test)

## End

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Greenbone AG
#
# SPDX-License-Identifier: GPL-2.0-or-later

## Program

## Dependency checks

include (FindPkgConfig)

if (NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "pkg-config executable not found. Aborting.")
endif (NOT PKG_CONFIG_FOUND)

pkg_check_modules (LIBGVM_BASE REQUIRED libgvm_base>=22.4)
pkg_check_modules (LIBGVM_BOREAS REQUIRED libgvm_boreas>=22.4)
pkg_check_modules (LIBGVM_UTIL REQUIRED libgvm_util>=22.4)
pkg_check_modules (GLIB REQUIRED glib-2.0>=2.42)
pkg_check_modules (LIBBSD REQUIRED libbsd)

message (STATUS "Looking for libgcrypt...")
pkg_check_modules (GCRYPT REQUIRED libgcrypt)

message (STATUS "Looking for pcap...")
find_library (PCAP pcap)
message (STATUS "Looking for pcap... ${PCAP}")
if (NOT PCAP)
  message (SEND_ERROR "The pcap library is required.")
endif (NOT PCAP)

message (STATUS "Looking for pcap-config...")
find_program (PCAP_CONFIG pcap-config)

if (PCAP_CONFIG)
  message (STATUS "Looking for pcap-config... ${PCAP_CONFIG}")
  execute_process (COMMAND pcap-config --libs
    OUTPUT_VARIABLE PCAP_LDFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  string(STRIP ${PCAP_LDFLAGS} PCAP_LDFLAGS)
  execute_process (COMMAND pcap-config --cflags
    OUTPUT_VARIABLE PCAP_CFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
else (PCAP_CONFIG)
  message (STATUS "pcap-config not found, using defaults...")
  set (PCAP_LDFLAGS "-L/usr/lib -lpcap")
  set (PCAP_CFLAGS "-I/usr/include")
endif (PCAP_CONFIG)

find_package (Threads)

add_executable (openvas attack.c debug_utils.c hosts.c
                main.c nasl_plugins.c openvas.c
                pluginlaunch.c pluginload.c
                pluginscheduler.c plugs_req.c
                processes.c sighand.c utils.c)

set_target_properties (openvas PROPERTIES LINKER_LANGUAGE C)

include_directories (${GLIB_INCLUDE_DIRS}
                     ${LIBBSD_INCLUDE_DIRS}
                     ${LIBOPENVAS_NASL_INCLUDE_DIRS}
                     ${LIBGVM_BASE_INCLUDE_DIRS}
                     ${LIBOPENVAS_MISC_INCLUDE_DIRS}
                     ${GCRYPT_INCLUDE_DIRS})

if (NOT CMAKE_BUILD_TYPE MATCHES "Release")
  # If we got GIT_REVISION at configure time,
  # assume we can get it at build time as well
  if (GIT_REVISION)
    # a custom target that is always built
    add_custom_target (revisiontag ALL)

    # creates gitversion.h using cmake script
    add_custom_command (TARGET revisiontag POST_BUILD COMMAND ${CMAKE_COMMAND}
                        -DSOURCE_DIR=${CMAKE_SOURCE_DIR}
                        -P ${CMAKE_SOURCE_DIR}/cmake/GetGit.cmake)

    # explicitly say that the executable depends on custom target
    add_dependencies (openvas revisiontag)

    # include the output directory, where the gitversion.h file is generated
    include_directories (${CMAKE_CURRENT_BINARY_DIR})
    add_definitions (-DGIT_REV_AVAILABLE)
  endif (GIT_REVISION)
endif (NOT CMAKE_BUILD_TYPE MATCHES "Release")

set (CMAKE_C_FLAGS_DEBUG        "${CMAKE_C_FLAGS_DEBUG} -Werror -Wextra")

if (OPENVAS_VERSION)
  add_definitions (-DOPENVAS_VERSION="${OPENVAS_VERSION}")
endif (OPENVAS_VERSION)

if (GIT_REVISION)
  add_definitions (-DOPENVAS_GIT_REVISION="${GIT_REVISION}")
endif (GIT_REVISION)

add_definitions (-DPREFIX="${CMAKE_INSTALL_PREFIX}")

if (OPENVAS_NVT_DIR)
  add_definitions (-DOPENVAS_NVT_DIR="${OPENVAS_NVT_DIR}")
endif (OPENVAS_NVT_DIR)

if (OPENVAS_CONF)
  add_definitions (-DOPENVAS_CONF="${OPENVAS_CONF}")
endif (OPENVAS_CONF)

if (OPENVAS_STATE_DIR)
  add_definitions (-DOPENVAS_STATE_DIR="${OPENVAS_STATE_DIR}")
endif (OPENVAS_STATE_DIR)

if (OPENVAS_RUN_DIR)
  add_definitions (-DOPENVAS_RUN_DIR="${OPENVAS_RUN_DIR}")
endif (OPENVAS_RUN_DIR)

if (SYSCONFDIR)
  add_definitions (-DSYSCONFDIR="${SYSCONFDIR}")
endif (SYSCONFDIR)

if (OPENVAS_SYSCONF_DIR)
  add_definitions (-DOPENVAS_SYSCONF_DIR="${OPENVAS_SYSCONF_DIR}")
endif (OPENVAS_SYSCONF_DIR)

if (OPENVAS_DATA_DIR)
  add_definitions (-DOPENVAS_DATA_DIR="${OPENVAS_DATA_DIR}")
endif (OPENVAS_DATA_DIR)

if (NVT_TIMEOUT)
  add_definitions (-DNVT_TIMEOUT=${NVT_TIMEOUT})
endif (NVT_TIMEOUT)

if (SCANNER_NVT_TIMEOUT)
  add_definitions (-DSCANNER_NVT_TIMEOUT=${SCANNER_NVT_TIMEOUT})
endif (SCANNER_NVT_TIMEOUT)

if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  set (EXECINFO_LDFLAGS "execinfo")
endif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")

target_link_libraries (openvas openvas_nasl_shared ${LIBOPENVAS_NASL_LDFLAGS}
                       ${LIBOPENVAS_MISC_LDFLAGS}
                       ${LIBGVM_BASE_LDFLAGS}
                       ${LIBGVM_BOREAS_LDFLAGS}
                       ${LIBBSD_LDFLAGS} ${GLIB_LDFAGS} ${GCRYPT_LDFLAGS}
                       ${EXECINFO_LDFLAGS} ${PCAP_LDFLAGS}
                       ${LINKER_HARDENING_FLAGS} ${CMAKE_THREAD_LIBS_INIT})

## Tests

add_executable (attack-test
                EXCLUDE_FROM_ALL
                attack_tests.c debug_utils.c
                hosts.c nasl_plugins.c openvas.c
                pluginlaunch.c pluginload.c
                pluginscheduler.c plugs_req.c
                processes.c sighand.c utils.c)

set_target_properties (attack-test PROPERTIES LINKER_LANGUAGE C)

target_compile_options(attack-test PRIVATE "-fsanitize=address")
target_link_options(attack-test PRIVATE "-fsanitize=address")

add_test (attack-test attack-test)

set_tests_properties(
  attack-test
  PROPERTIES
    ENVIRONMENT "ASAN_OPTIONS=detect_leaks=1:halt_on_error=1:abort_on_error=1"
)

target_link_libraries (attack-test openvas_nasl_shared cgreen
                       ${LIBOPENVAS_NASL_LDFLAGS}
                       ${LIBOPENVAS_MISC_LDFLAGS}
                       ${LIBGVM_BASE_LDFLAGS}
                       ${LIBGVM_BOREAS_LDFLAGS}
                       ${LIBBSD_LDFLAGS} ${GLIB_LDFAGS} ${GCRYPT_LDFLAGS}
                       ${EXECINFO_LDFLAGS} ${PCAP_LDFLAGS}
                       ${LINKER_HARDENING_FLAGS} ${CMAKE_THREAD_LIBS_INIT}
                       -Wl,--wrap=redis_push_str)

## Static analysis

add_custom_target (cppcheck COMMENT "Running cppcheck..."
                   COMMAND sh -c \"cppcheck ${CMAKE_CURRENT_SOURCE_DIR}\")

add_custom_target (check COMMENT "Checking code...")
add_dependencies (check cppcheck)

## Tag files

set (C_FILES "attack.c" "hosts.c"
     "nasl_plugins.c" "openvas.c"
     "pluginlaunch.c" "pluginload.c"
     "pluginscheduler.c" "plugs_req.c"
     "processes.c" "sighand.c" "utils.c"
     "debug_utils.c")
add_custom_target (etags COMMENT "Building TAGS..."
                   COMMAND etags ${C_FILES})
add_custom_target (ctags COMMENT "Building tags..."
                   COMMAND ctags ${C_FILES})
add_custom_target (tags COMMENT "Building tags files...")
add_dependencies (tags etags ctags)

## Install

install (TARGETS openvas
         RUNTIME DESTINATION ${SBINDIR}
         PERMISSIONS OWNER_EXECUTE OWNER_READ OWNER_WRITE
         GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install (FILES ${CMAKE_BINARY_DIR}/src/openvas_log.conf
         DESTINATION ${OPENVAS_SYSCONF_DIR})

install (FILES ${CMAKE_BINARY_DIR}/doc/man/openvas.8
         DESTINATION ${DATADIR}/man/man8 )

install (DIRECTORY DESTINATION ${OPENVAS_NVT_DIR})

## End

=== rust/openvasd-tests/Makefile ===
#!/usr/bin/env bash

DOCKER_IMAGE = openvasd-test
CONTAINER_NAME = openvasd-test-container
PORT = 3000
API_KEY = changeme
PROFILE ?= release

.PHONY: build start-scanner openvas ospd-openvas clean status

build:
	@echo "Building openvasd locally in $(PROFILE) mode..."
	cd .. && cargo build --profile=$(PROFILE) --bin openvasd
	@echo "Building Docker image..."
	docker build -t $(DOCKER_IMAGE) -f Dockerfile ../..
	@echo "Build complete!"

start-scanner: build
	@echo "Starting openvasd with $(SCANNER_TYPE) backend..."
	@docker rm -f $(CONTAINER_NAME) 2>/dev/null || true
	docker run -d \
               --rm \
		--name $(CONTAINER_NAME) \
		-p $(PORT):3000 \
		-e SCANNER_TYPE=$(SCANNER_TYPE) \
		-e API_KEY=$(API_KEY) \
		-v "$(realpath ../target):/opt/openvasd_target" \
		-e PROFILE=$(PROFILE) \
		$(DOCKER_IMAGE)
	@echo "Container started. Waiting for service to be ready..."
	@for i in $$(seq 1 20); do \
		if curl -f -s -H "X-Api-Key: $(API_KEY)" http://localhost:$(PORT)/health/ready >/dev/null 2>&1; then \
			echo "openvasd ready"; \
			break; \
		fi; \
		if [ $$i -eq 20 ]; then \
			echo "Timeout: openvasd not ready after 10 seconds"; \
			exit 1; \
		fi; \
		sleep 0.5; \
	done

discovery:
	@echo "Running discovery scan..."
	/usr/bin/env bash ../examples/openvasd/start-discovery.sh

openvas:
	@$(MAKE) start-scanner SCANNER_TYPE=openvas

ospd:
	@$(MAKE) start-scanner SCANNER_TYPE=ospd

logs: 
	docker logs -f $(CONTAINER_NAME)

rebuild: clean build

shell:  build
	docker exec -it $(CONTAINER_NAME) /bin/bash

status: 
	@curl -v -s -H "X-Api-Key: $(API_KEY)" http://localhost:$(PORT)/health/ready

clean: 
	@echo "Stopping and removing container..."
	@docker rm -f $(CONTAINER_NAME) 2>/dev/null || true
	@echo "Cleanup complete!"

=== rust/examples/container_image_scanning/Makefile ===
BASE_PATH := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

.DEFAULT_GOAL := start


SCAN_DIR := scans
STARTED_SCAN_DIR := known-scans

JSON_FILES := $(wildcard $(SCAN_DIR)/*.json)

BASE_NAMES := $(basename $(notdir $(JSON_FILES)))
CREATE_TARGETS :=  $(addprefix create-,$(BASE_NAMES))

CREATED_SCANS := $(wildcard $(STARTED_SCAN_DIR)/*)
SCANS_BASE_NAMES := $(basename $(notdir $(CREATED_SCANS)))

START_TARGETS := $(addprefix start-,$(SCANS_BASE_NAMES))
STOP_TARGETS := $(addprefix stop-,$(SCANS_BASE_NAMES))
RM_TARGETS := $(addprefix rm-,$(SCANS_BASE_NAMES))
RESULTS_TARGETS := $(addprefix results-,$(SCANS_BASE_NAMES))
STATUS_TARGETS := $(addprefix status-,$(SCANS_BASE_NAMES))

STARTED_SCANS := $(wildcard $(STARTED_SCAN_DIR)/*)

START_SCANS := $(basename $(notdir $(JSON_FILES)))

CIS_ADDRESS := http://localhost:3000/container-image-scanner/

.PHONY: stop-notus start-notus rm-notus stop-local-registry start-local-registry rm-local-registry \
        $(CREATE_TARGETS) $(START_TARGETS) $(STOP_TARGETS) $(RM_TARGETS) $(RESULTS_TARGETS) $(STATUS_TARGETS) \
        start stop rm



stop-notus:
	@cd ${BASE_PATH}/notus/; make stop

start-notus:
	@cd ${BASE_PATH}/notus/; make start

rm-notus:
	@cd ${BASE_PATH}/notus/; make rm

stop-local-registry:
	@cd ${BASE_PATH}/local-registry/; make stop

start-local-registry:
	@cd ${BASE_PATH}/local-registry/; make start-mirror

rm-local-registry:
	@cd ${BASE_PATH}/local-registry/; make rm

$(CREATE_TARGETS):
	$(eval TARGET_NAME := $(patsubst create-%,%,$@))
	@ curl -s -X POST -H "Content-Type: application/json" \
		--data-binary @$(SCAN_DIR)/$(TARGET_NAME).json \
		$(CIS_ADDRESS)/scans | sed 's/"//g' > $(STARTED_SCAN_DIR)/$(TARGET_NAME)


$(START_TARGETS):
	$(eval TARGET_NAME := $(patsubst start-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	curl -s -d '{"action": "start"}' $(CIS_ADDRESS)/scans/$$ID

$(STOP_TARGETS):
	$(eval TARGET_NAME := $(patsubst stop-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	curl -s -d '{"action": "stop"}' $(CIS_ADDRESS)/scans/$$ID

$(RM_TARGETS):
	$(eval TARGET_NAME := $(patsubst rm-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	curl -s -X DELETE $(CIS_ADDRESS)/scans/$$ID && \
	rm $(STARTED_SCAN_DIR)/$(TARGET_NAME)

$(RESULTS_TARGETS):
	$(eval TARGET_NAME := $(patsubst results-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	curl -s $(CIS_ADDRESS)/scans/$$ID/results | jq

$(STATUS_TARGETS):
	$(eval TARGET_NAME := $(patsubst status-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	curl -s $(CIS_ADDRESS)/scans/$$ID/status | jq

../../target/release/openvasd:
	@cargo build --release > /dev/null 2>&1

container-image-scanner.pid: ../../target/release/openvasd 
	@sh ./start-container-image-scanner.sh

.PHONY: start-container-image-scanner
start-container-image-scanner: container-image-scanner.pid

stop-container-image-scanner:
	@kill $$(cat container-image-scanner.pid 2> /dev/null) > /dev/null 2>&1 || true 
	@rm -f container-image-scanner.pid

rm-container-image-scanner: stop-container-image-scanner
	@rm -f ../../target/release/openvasd
	@rm -f container-image-scanner.log
	@rm -f example.db
	@rm -f example.db-shm
	@rm -f example.db-wal


stop: stop-notus stop-local-registry stop-container-image-scanner

start: start-notus start-local-registry start-container-image-scanner

rm: rm-notus rm-local-registry rm-container-image-scanner

=== rust/examples/container_image_scanning/local-registry/Makefile ===
.PHONY := auth-server,docker-registry
USER :="holla"
PASSWORD :="diewaldfee"
BASE_PATH := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

.DEFAULT_GOAL := start

# Parameter:
# 1: the name of the container to start
# 2: the make command to execute if container name was not found
define start_container
@if docker ps -a --format '{{.Names}}' | grep -wq $(1); then \
	echo "Starting existing container: $(1)"; \
	docker start $(1); \
else \
	echo "Container $(1) not found. Running: $(2)"; \
	$(MAKE) $(2); \
fi
endef

IMAGES_FILE := images
LOCAL_REGISTRY := localhost:5000

rm-local-images:
	@echo "Removing images pulled by mirror-images."
	@while IFS= read -r image; do \
		if [ -n "$$image" ]; then \
			echo "removing $$image"; \
			docker rmi $$image 2> /dev/null || true ; \
		fi \
	done < $(IMAGES_FILE)


mirror-images:
	@echo "Begin mirroring images to $(LOCAL_REGISTRY)."
	@while IFS= read -r image; do \
		if [ -n "$$image" ]; then \
			echo "docker pull $$image"; \
			docker pull $$image > /dev/null 2>&1; \
			repo_tag=$$(echo $$image | sed 's|.*/||'); \
			local_tag=$(LOCAL_REGISTRY)/$$image; \
			echo "docker tag $$image $$local_tag"; \
			docker tag $$image $$local_tag > /dev/null 2>&1; \
			echo "docker push $$local_tag"; \
			docker push $$local_tag > /dev/null 2>&1; \
			docker rmi $$local_tag > /dev/null 2>&1; \
		fi \
	done < $(IMAGES_FILE)
	@echo "End $(LOCAL_REGISTRY)."


certs/domain.crt:
	openssl req -newkey rsa:4096 -nodes -sha256 -keyout certs/domain.key \
	  -x509 -days 365 -out certs/domain.crt \
	  -subj "/CN=localhost"

auth-server:
	docker run -d \
		--name auth_server \
		-p 5001:5001 \
		-v "$(BASE_PATH)/config:/config" \
		-v "$(BASE_PATH)/auth:/config/auth" \
		-v "$(BASE_PATH)/certs:/certs" \
		cesanta/docker_auth

stop-auth-server:
	docker stop auth_server

start-auth-server:
	$(call start_container,auth_server,auth-server)

rm-auth-server: stop-auth-server
	docker rm auth_server

docker-registry: 
	docker run -d \
		--name registry \
		-p 5000:5000 \
		-v "$(BASE_PATH)/certs:/certs" \
		-e REGISTRY_AUTH=token \
		-e REGISTRY_HTTP_TLS_CERTIFICATE=/certs/domain.crt \
		-e REGISTRY_HTTP_TLS_KEY=/certs/domain.key \
		-e REGISTRY_AUTH_TOKEN_REALM=https://localhost:5001/auth \
		-e REGISTRY_AUTH_TOKEN_SERVICE=localhost:5000 \
		-e REGISTRY_AUTH_TOKEN_ISSUER=MyAuthServer \
		-e REGISTRY_AUTH_TOKEN_ROOTCERTBUNDLE=/certs/domain.crt \
		registry:2

stop-docker-registry:
	docker stop registry

start-docker-registry:
	$(call start_container,registry,docker-registry)

stop: stop-auth-server stop-docker-registry

start: certs/domain.crt start-auth-server start-docker-registry

start-mirror: start mirror-images

rm-docker-registry: stop-docker-registry
	docker rm registry

rm: rm-docker-registry rm-auth-server

=== rust/examples/feed/nasl/Makefile ===
all: sha256sums

../../../target/release/scannerctl:
	cd ../../../ && cargo build --release

vt-metadata.json: ../../../target/release/scannerctl
	../../../target/release/scannerctl feed transform -p . > vt-metadata.json
	
sha256sums: vt-metadata.json
	find . -type f -regex ".*\.\(nasl\|inc\|json\)$$"  -exec sha256sum {} \; | tee sha256sums

rm:
	rm sha256sums
	rm vt-metadata.json

regenerate: rm sha256sums

=== rust/examples/container_image_scanning/tls/self-signed/Makefile ===
.PHONY: remove
ALL: generate
	
server.rsa:
	sh server_certificates.sh
client.rsa:
	sh client_certificates.sh

generate: server.rsa client.rsa

remove:
	rm server.rsa server.pem
	rm client.rsa client.pem

=== debian/changelog ===
openvas-scanner (23.30.1-1) unstable; urgency=medium

  * New upstream version 23.30.1
  * Refresh patches
  * Update debian/watch to Version 5
  * Update build-dep: add libmagic-dev
  * Update debian/copyright
  * Add dep on gpg-agent

 -- Sophie Brun <sophie@kali.org>  Thu, 13 Nov 2025 09:23:54 +0100

=== debian/control ===
Source: openvas-scanner
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sophie Brun <sophie@kali.org>
Build-Depends: debhelper-compat (= 13),
               bison,
               cmake,
               pkgconf,
	       libcurl4-gnutls-dev,
               libglib2.0-dev,
	       libbsd-dev,
	       libjson-glib-dev,
               libgcrypt20-dev,
               libgnutls28-dev,
	       libmagic-dev,
	       libpaho-mqtt-dev,
               libpcap-dev,
               libgvm-dev (>= 22.6.3),
               doxygen,
# Exclude those two architectures until cgreen is fixed:
# https://github.com/cgreen-devs/cgreen/issues/227
# https://github.com/cgreen-devs/cgreen/issues/239
               libcgreen1-dev [!ppc64el !s390x]
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.greenbone.net/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/openvas-scanner
Vcs-Git: https://salsa.debian.org/pkg-security-team/openvas-scanner.git

Package: openvas-scanner
Section: net
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl, redis-server,
         adduser, rsync, gpg, gpg-agent
Replaces: openvas-server, openvas-plugins, libopenvas-dev, openvas-nasl
Conflicts: openvas-server, openvas-plugins, libopenvas-dev, openvas-nasl
Recommends: nmap, python3-impacket
Suggests: gvm-tools, snmp, pnscan, strobe, ike-scan
Description: remote network security auditor - scanner
 The Open Vulnerability Assessment System is a modular security auditing
 tool, used for testing remote systems for vulnerabilities that should be
 fixed.
 .
 It is made up of two parts: a scan server, and a client. The scanner/daemon,
 openvassd, is in charge of the attacks, whereas the client,
 gvm-tools, provides an X11/GTK+ user interface.
 .
 This package provides the scanner.

=== debian/watch ===
Version: 5
Template: Github
Owner: greenbone
Project: openvas-scanner

## openvas-scanner 23.32.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.30.1
+  VERSION 23.32.5
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== compose/Makefile ===
all: openvasd-server.key client-certs/client1.pem

openvasd-server.key:
	cd ../rust/examples/tls/self-signed/ && make
	mv ../rust/examples/tls/self-signed/server.pem openvasd-server.pem
	mv ../rust/examples/tls/self-signed/server.rsa openvasd-server.key

client-certs/client1.pem:
	mkdir -p client-certs
	mkdir -p client-keys
	cd ../rust/examples/tls/self-signed/ && make
	mv ../rust/examples/tls/self-signed/server.pem client-certs/client1.pem
	mv ../rust/examples/tls/self-signed/server.rsa client-keys/client1.key

=== debian/changelog ===
openvas-scanner (23.32.5-1) unstable; urgency=medium

  * New upstream version 23.32.5
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Fri, 05 Dec 2025 11:23:55 +0100

## openvas-scanner 23.32.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.32.5
+  VERSION 23.32.6
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== compose/tests/Makefile ===
SCAN_DIR := scans
STARTED_SCAN_DIR := known-scans

JSON_FILES := $(wildcard $(SCAN_DIR)/*.json)

BASE_NAMES := $(basename $(notdir $(JSON_FILES)))
CREATE_TARGETS :=  $(addprefix create-,$(BASE_NAMES))

CREATED_SCANS := $(wildcard $(STARTED_SCAN_DIR)/*)
SCANS_BASE_NAMES := $(basename $(notdir $(CREATED_SCANS)))

START_TARGETS := $(addprefix start-,$(SCANS_BASE_NAMES))
STOP_TARGETS := $(addprefix stop-,$(SCANS_BASE_NAMES))
RM_TARGETS := $(addprefix rm-,$(SCANS_BASE_NAMES))
RESULTS_TARGETS := $(addprefix results-,$(SCANS_BASE_NAMES))
STATUS_TARGETS := $(addprefix status-,$(SCANS_BASE_NAMES))

STARTED_SCANS := $(wildcard $(STARTED_SCAN_DIR)/*)

START_SCANS := $(basename $(notdir $(JSON_FILES)))

CURL := curl -vk --key ../client-keys/client1.key --cert ../client-certs/client1.pem 
CIS_ADDRESS := https://localhost:3000

$(CREATE_TARGETS):
	$(eval TARGET_NAME := $(patsubst create-%,%,$@))
	${CURL} -X POST -H "Content-Type: application/json" \
		--data-binary @$(SCAN_DIR)/$(TARGET_NAME).json \
		$(CIS_ADDRESS)/scans | sed 's/"//g' > $(STARTED_SCAN_DIR)/$(TARGET_NAME)


$(START_TARGETS):
	$(eval TARGET_NAME := $(patsubst start-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	${CURL} -d '{"action": "start"}' $(CIS_ADDRESS)/scans/$$ID

$(STOP_TARGETS):
	$(eval TARGET_NAME := $(patsubst stop-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	${CURL} -d '{"action": "stop"}' $(CIS_ADDRESS)/scans/$$ID

$(RM_TARGETS):
	$(eval TARGET_NAME := $(patsubst rm-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	${CURL} -X DELETE $(CIS_ADDRESS)/scans/$$ID && \
	rm $(STARTED_SCAN_DIR)/$(TARGET_NAME)

$(RESULTS_TARGETS):
	$(eval TARGET_NAME := $(patsubst results-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	${CURL} $(CIS_ADDRESS)/scans/$$ID/results | jq

$(STATUS_TARGETS):
	$(eval TARGET_NAME := $(patsubst status-%,%,$@))
	@ID=$$(cat $(STARTED_SCAN_DIR)/$(TARGET_NAME)) && \
	${CURL} $(CIS_ADDRESS)/scans/$$ID/status | jq

=== debian/changelog ===
openvas-scanner (23.32.6-1) unstable; urgency=medium

  * New upstream version 23.32.6
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Mon, 08 Dec 2025 14:10:33 +0100

## openvas-scanner 23.35.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.32.6
+  VERSION 23.35.3
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== debian/changelog ===
openvas-scanner (23.35.3-1parrot1) echo; urgency=medium

  * Import new Debian testing version.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 18 Dec 2025 18:59:19 +0100

openvas-scanner (23.35.3-1) unstable; urgency=medium

  * New upstream version 23.35.3
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Wed, 17 Dec 2025 09:27:55 +0100

## openvas-scanner 23.35.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.35.3
+  VERSION 23.35.4
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== debian/changelog ===
openvas-scanner (23.35.4-1) unstable; urgency=medium

  * New upstream version 23.35.4
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 11:34:31 +0100

## openvas-scanner 23.36.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.35.4
+  VERSION 23.36.1
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== debian/changelog ===
openvas-scanner (23.36.1-1) unstable; urgency=medium

  * New upstream version 23.36.1
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 15 Jan 2026 11:31:19 +0100

## openvas-scanner 23.38.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.36.1
+  VERSION 23.38.0
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== rust/examples/container_image_scanning/local-registry/Makefile ===
--- 
+++ 
@@ -5,13 +5,29 @@
 
 .DEFAULT_GOAL := start
 
+CONTAINER := $(shell command -v docker 2>/dev/null || command -v podman)
+
+ifeq ($(CONTAINER),docker)
+    PULL_CMD := $(CONTAINER) pull
+else
+    PULL_CMD := $(CONTAINER) pull --tls-verify=false
+endif
+
+ifeq ($(CONTAINER),docker)
+    PUSH_CMD := $(CONTAINER) push
+else
+    PUSH_CMD := $(CONTAINER) push --tls-verify=false
+endif
+
+
+
 # Parameter:
 # 1: the name of the container to start
 # 2: the make command to execute if container name was not found
 define start_container
-@if docker ps -a --format '{{.Names}}' | grep -wq $(1); then \
+@if $(CONTAINER) ps -a --format '{{.Names}}' | grep -wq $(1); then \
 	echo "Starting existing container: $(1)"; \
-	docker start $(1); \
+	$(CONTAINER) start $(1); \
 else \
 	echo "Container $(1) not found. Running: $(2)"; \
 	$(MAKE) $(2); \
@@ -26,7 +42,7 @@
 	@while IFS= read -r image; do \
 		if [ -n "$$image" ]; then \
 			echo "removing $$image"; \
-			docker rmi $$image 2> /dev/null || true ; \
+			$(CONTAINER) rmi $$image 2> /dev/null || true ; \
 		fi \
 	done < $(IMAGES_FILE)
 
@@ -35,15 +51,15 @@
 	@echo "Begin mirroring images to $(LOCAL_REGISTRY)."
 	@while IFS= read -r image; do \
 		if [ -n "$$image" ]; then \
-			echo "docker pull $$image"; \
-			docker pull $$image > /dev/null 2>&1; \
+			echo "$(PULL_CMD) $$image"; \
+			$(PULL_CMD) $$image > /dev/null 2>&1; \
 			repo_tag=$$(echo $$image | sed 's|.*/||'); \
 			local_tag=$(LOCAL_REGISTRY)/$$image; \
-			echo "docker tag $$image $$local_tag"; \
-			docker tag $$image $$local_tag > /dev/null 2>&1; \
-			echo "docker push $$local_tag"; \
-			docker push $$local_tag > /dev/null 2>&1; \
-			docker rmi $$local_tag > /dev/null 2>&1; \
+			echo "$(CONTAINER) tag $$image $$local_tag"; \
+			$(CONTAINER) tag $$image $$local_tag > /dev/null 2>&1; \
+			echo "$(PUSH_CMD) $$local_tag"; \
+			$(PUSH_CMD) $$local_tag > /dev/null 2>&1; \
+			$(CONTAINER) rmi $$local_tag > /dev/null 2>&1; \
 		fi \
 	done < $(IMAGES_FILE)
 	@echo "End $(LOCAL_REGISTRY)."
@@ -55,7 +71,7 @@
 	  -subj "/CN=localhost"
 
 auth-server:
-	docker run -d \
+	$(CONTAINER) run -d \
 		--name auth_server \
 		-p 5001:5001 \
 		-v "$(BASE_PATH)/config:/config" \
@@ -64,16 +80,16 @@
 		cesanta/docker_auth
 
 stop-auth-server:
-	docker stop auth_server
+	$(CONTAINER) stop auth_server
 
 start-auth-server:
 	$(call start_container,auth_server,auth-server)
 
 rm-auth-server: stop-auth-server
-	docker rm auth_server
+	$(CONTAINER) rm auth_server
 
 docker-registry: 
-	docker run -d \
+	$(CONTAINER) run -d \
 		--name registry \
 		-p 5000:5000 \
 		-v "$(BASE_PATH)/certs:/certs" \
@@ -87,7 +103,7 @@
 		registry:2
 
 stop-docker-registry:
-	docker stop registry
+	$(CONTAINER) stop registry
 
 start-docker-registry:
 	$(call start_container,registry,docker-registry)
@@ -99,6 +115,6 @@
 start-mirror: start mirror-images
 
 rm-docker-registry: stop-docker-registry
-	docker rm registry
+	$(CONTAINER) rm registry
 
 rm: rm-docker-registry rm-auth-server

=== debian/changelog ===
openvas-scanner (23.38.0-1) unstable; urgency=medium

  * New upstream version 23.38.0
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Wed, 21 Jan 2026 12:01:26 +0100

## openvas-scanner 23.38.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.38.0
+  VERSION 23.38.1
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== debian/changelog ===
openvas-scanner (23.38.1-1build1) resolute; urgency=medium

  * No-change rebuild for gpgme1.0 2.0

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Sat, 21 Feb 2026 14:34:28 +0000

openvas-scanner (23.38.1-1) unstable; urgency=medium

  * New upstream version 23.38.1
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 29 Jan 2026 15:25:09 +0100

## openvas-scanner 23.40.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.38.1
+  VERSION 23.40.2
   LANGUAGES C)
 
 if (POLICY CMP0005)

=== rust/examples/container_image_scanning/Makefile ===
--- 
+++ 
@@ -26,20 +26,11 @@
 
 CIS_ADDRESS := http://localhost:3000/container-image-scanner/
 
-.PHONY: stop-notus start-notus rm-notus stop-local-registry start-local-registry rm-local-registry \
+.PHONY: stop-local-registry start-local-registry rm-local-registry \
         $(CREATE_TARGETS) $(START_TARGETS) $(STOP_TARGETS) $(RM_TARGETS) $(RESULTS_TARGETS) $(STATUS_TARGETS) \
         start stop rm
 
 
-
-stop-notus:
-	@cd ${BASE_PATH}/notus/; make stop
-
-start-notus:
-	@cd ${BASE_PATH}/notus/; make start
-
-rm-notus:
-	@cd ${BASE_PATH}/notus/; make rm
 
 stop-local-registry:
 	@cd ${BASE_PATH}/local-registry/; make stop
@@ -104,8 +95,8 @@
 	@rm -f example.db-wal
 
 
-stop: stop-notus stop-local-registry stop-container-image-scanner
+stop: stop-local-registry stop-container-image-scanner
 
-start: start-notus start-local-registry start-container-image-scanner
+start: start-local-registry start-container-image-scanner
 
-rm: rm-notus rm-local-registry rm-container-image-scanner
+rm: rm-local-registry rm-container-image-scanner

=== debian/changelog ===
openvas-scanner (23.40.2-1) unstable; urgency=medium

  * New upstream version 23.40.2
  * Refresh patches
  * Fix build on 32 bit arch

 -- Sophie Brun <sophie@kali.org>  Wed, 25 Feb 2026 15:05:17 +0100
